import 'package:accordion/accordion.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikAccordionProps.dart';
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';

class UikAccordion extends UikWidget {
  WidgetType _widgetType;
  UikAccordionProps _UikAccordionProps;
  UikAccordion(this._widgetType, this._UikAccordionProps)
      : super(_widgetType, _UikAccordionProps);

  @override
  _UikAccordionState createState() => _UikAccordionState(_UikAccordionProps);
}

class _UikAccordionState extends State<UikAccordion> {
  final UikAccordionProps _UikAccordionProps;
  _UikAccordionState(this._UikAccordionProps);

  @override
  Widget build(BuildContext context) {
    return Accordion(
      headerBorderRadius: _UikAccordionProps.headerBorderRadius,
      headerBackgroundColor: _UikAccordionProps.headerBackgroundColor
          .withOpacity(_UikAccordionProps.opacity),
      contentBackgroundColor: _UikAccordionProps.contentBackgroundColor
          .withOpacity(_UikAccordionProps.opacity),
      contentBorderColor: _UikAccordionProps.contentBorderColor
          .withOpacity(_UikAccordionProps.opacity),
      paddingListBottom: _UikAccordionProps.paddingListBottom,
      paddingListTop: _UikAccordionProps.paddingListTop,
      children: [
        AccordionSection(
          rightIcon: _UikAccordionProps.rightComponent,
          header: _UikAccordionProps.headerComponent,
          content: _UikAccordionProps.contentComponent,
          contentHorizontalPadding: _UikAccordionProps.contentHorizontalPadding,
          contentVerticalPadding: _UikAccordionProps.contentVerticalPadding,
          contentBorderRadius: _UikAccordionProps.headerBorderRadius,
        ),
      ],
    );
  }
}
