import 'package:google_fonts/google_fonts.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:flutter/material.dart';
import '../props/UikBagItemProps.dart';

class UikBagItem extends UikWidget {
  WidgetType _widgetType;
  UikBagItemProps _uikBagItemProps;
  UikBagItem(this._widgetType, this._uikBagItemProps)
      : super(_widgetType, _uikBagItemProps);

  @override
  _UikBagItemState createState() => _UikBagItemState(_uikBagItemProps);
}

class _UikBagItemState extends State<UikBagItem> {
  UikBagItemProps _uikBagItemProps;
  _UikBagItemState(this._uikBagItemProps);

  @override
  Widget build(BuildContext context) {
    return Column(
      crossAxisAlignment: CrossAxisAlignment.start,
      children: [
        Container(
          width: 400,
          height: 150,
          child: Row(
            children: [
              //............................................Image...................................................//
              Flexible(
                child: Container(
                  width: 94,
                  height: 115,
                  margin: EdgeInsets.only(left: 16),
                  decoration: BoxDecoration(
                    borderRadius: BorderRadius.circular(8),
                    image: DecorationImage(
                      image: NetworkImage(_uikBagItemProps.imageUrl),
                      fit: BoxFit.cover,
                    ),
                    // shape: BoxShape.circle,
                  ),
                ),
              ),
              SizedBox(width: 16),
              //...............................................ImgPrice.........................................//
              Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  SizedBox(height: 14),
                  Container(
                    width: 201,
                    height: 24,
                    child: Text(
                      _uikBagItemProps.productPrice,
                      style: TextStyle(
                        fontFamily: GoogleFonts.poppins().fontFamily,
                        fontWeight: FontWeight.w500,
                        fontSize: 16,
                        color: Color(0xFF212121),
                      ),
                    ),
                  ),
                  //........................................................ImgDescription..............................//
                  Container(
                    width: 201,
                    height: 32,
                    // color: Colors.black,
                    child: Text(
                      _uikBagItemProps.productDescription,
                      style: TextStyle(
                        fontWeight: FontWeight.w400,
                        fontFamily: GoogleFonts.poppins().fontFamily,
                        fontSize: 12,
                        color: Color(0xFF9E9E9E),
                      ),
                    ),
                  ),
                  const SizedBox(height: 20),
                  Container(
                    child: (_uikBagItemProps.deleteIcon != null)
                        ? _uikBagItemProps.deleteIcon
                        : null,
                  ),
                ],
              ),
            ],
          ),
        ),
      ],
    );
  }
}
