
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/utils/UikActionListner.dart';
import 'package:flutter/material.dart';


class UikButton extends UikWidget {
  WidgetType _widgetType;
  UikButtonProps _uikButtonProps;
  UikButton(
      this._widgetType,
      this._uikButtonProps,
      ) : super(_widgetType, _uikButtonProps);

  @override
  _UikButtonState createState() => _UikButtonState(_uikButtonProps);
}

class _UikButtonState extends State<UikButton> {
  UikButtonProps _uikButtonProps;
  _UikButtonState(this._uikButtonProps);


  @override
  Widget build(BuildContext context) {
    return InkWell(
      child: Container(
        width: _uikButtonProps.width,
        height: _uikButtonProps.height,
        margin: EdgeInsets.only(
          left: _uikButtonProps.leftMargin,
          bottom: _uikButtonProps.bottomMargin,
          right: _uikButtonProps.rightMargin,
          top: _uikButtonProps.topMargin,
        ),
        child: ElevatedButton.icon(
          onPressed: () async {
            await executeUikWidgetAction(_uikButtonProps.action);
          },
          icon: (_uikButtonProps.icon != null)
              ? _uikButtonProps.icon!
              : Container(),
          label: _uikButtonProps.text!,
          style: ElevatedButton.styleFrom(
            backgroundColor: _uikButtonProps.backgroundColor,
            elevation: _uikButtonProps.elevation,
            padding: EdgeInsets.symmetric(
              horizontal: _uikButtonProps.horizontalPadding!,
              vertical: _uikButtonProps.verticalPadding!,
            ),
            shape: RoundedRectangleBorder(
              borderRadius:
              BorderRadius.circular(_uikButtonProps.borderRadius!),
              side: BorderSide(color: _uikButtonProps.borderColor),
            ),
          ),
        ),
      ),
    );
  }
}
