import 'package:google_fonts/google_fonts.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikIconProps.dart';
import "package:flutter/material.dart";
import 'package:ui_sdk/utils/UikActionListner.dart';
import 'package:ui_sdk/utils/pubsub/localpubsub.dart';

import '../props/UikChipsProps.dart';
import '../props/UikContainerTextProps.dart';
import 'UikIcon.dart';
import 'UikWidget.dart';

class UikContainerText extends UikWidget {
  WidgetType _widgetType;
  UikContainerTextProps _uikContainerTextProps;
  UikContainerText(this._widgetType, this._uikContainerTextProps)
      : super(_widgetType, _uikContainerTextProps);

  @override
  _UikContainerTextState createState() =>
      _UikContainerTextState(_uikContainerTextProps);
}

class _UikContainerTextState extends State<UikContainerText> {
  UikContainerTextProps _uikContainerTextProps;
  _UikContainerTextState(this._uikContainerTextProps);

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: () async {
        await executeUikWidgetAction(_uikContainerTextProps.action);
      },
      child: Container(
        width: _uikContainerTextProps.width,
        height: _uikContainerTextProps.height,
        margin: EdgeInsets.fromLTRB(
          _uikContainerTextProps.leftMargin,
          _uikContainerTextProps.topMargin,
          _uikContainerTextProps.rightMargin,
          _uikContainerTextProps.bottomMargin,
        ),
        child: _uikContainerTextProps.isStrike
            ? Row(
                mainAxisAlignment: _uikContainerTextProps.isCenter
                    ? MainAxisAlignment.center
                    : MainAxisAlignment.start,
                children: [
                  Text(
                    _uikContainerTextProps.text,
                    //overflow: _uikContainerTextProps.,
                    style: GoogleFonts.getFont(
                      _uikContainerTextProps.fontFamily,
                      fontSize: _uikContainerTextProps.size,
                      fontWeight: _uikContainerTextProps.normalFontWeight,
                      color: _uikContainerTextProps.color,
                      decoration: TextDecoration.none,
                    ),
                  ),
                  const SizedBox(width: 10.0),
                  Text(
                    _uikContainerTextProps.striketext,
                    //overflow: _uikContainerTextProps.,
                    style: GoogleFonts.getFont(
                      _uikContainerTextProps.fontFamily,
                      fontSize: _uikContainerTextProps.size,
                      fontWeight: _uikContainerTextProps.strikenFontWeight,
                      color: _uikContainerTextProps.color,
                      decoration: TextDecoration.lineThrough,
                    ),
                  )
                ],
              )
            : Text(
                _uikContainerTextProps.text,
                //overflow: _uikContainerTextProps.,
                style: GoogleFonts.getFont(
                  _uikContainerTextProps.fontFamily,
                  fontSize: _uikContainerTextProps.size,
                  fontWeight: _uikContainerTextProps.normalFontWeight,
                  color: _uikContainerTextProps.color,
                  decoration: TextDecoration.none,
                ),
              ),
      ),
    );
  }
}
