import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';

import '../props/UikProductCardProps.dart';

class UikProductCard extends UikWidget {
  WidgetType _widgetType;
  UikProductCardProps _uikProductCardProps;
  UikProductCard(this._widgetType, this._uikProductCardProps)
      : super(_widgetType, _uikProductCardProps);

  @override
  _UikProductCardState createState() =>
      _UikProductCardState(_uikProductCardProps);
}

class _UikProductCardState extends State<UikProductCard> {
  UikProductCardProps _uikProductCardProps;
  _UikProductCardState(this._uikProductCardProps);

  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: const EdgeInsets.symmetric(vertical: 10.0),
      child: Row(
        children: [
          Container(
            padding: const EdgeInsets.only(right: 32),
            width: 343,
            height: 115,
            margin: const EdgeInsets.only(left: 16),
            child: Row(
              children: [
                //............................................Image...................................................//
                Container(
                  decoration:
                      BoxDecoration(borderRadius: BorderRadius.circular(8)),
                  width: 94,
                  height: 115,
                  margin: const EdgeInsets.only(right: 16),
                  child: ClipRRect(
                    borderRadius: BorderRadius.circular(8),
                    child: Image(
                      fit: BoxFit.fill,
                      image: NetworkImage(_uikProductCardProps.imageUrl),
                    ),
                  ),
                ),

                //...............................................ImgPrice.........................................//
                Column(
                  crossAxisAlignment: CrossAxisAlignment.start,
                  children: [
                    Container(
                      margin: const EdgeInsets.only(bottom: 4),
                      child: Text(
                        _uikProductCardProps.productPrice,
                        style: TextStyle(
                          fontFamily: GoogleFonts.poppins().fontFamily,
                          fontWeight: FontWeight.w500,
                          fontSize: 16,
                          color: const Color(0xFF212121),
                        ),
                      ),
                    ),
                    //........................................................ImgDescription..............................//
                    SizedBox(
                      height: 32,
                      width: 200,
                      child: Text(
                        _uikProductCardProps.productDescription,
                        style: const TextStyle(
                          fontSize: 12,
                          fontWeight: FontWeight.w400,
                          color: Color(0xff9e9e9e),
                        ),
                      ),
                    ),
                    const SizedBox(
                      height: 18,
                    ),
                    SizedBox(
                      width: 200,
                      height: 36,
                      child: _uikProductCardProps.trailing,
                    )
                  ],
                ),
              ],
            ),
          ),
        ],
      ),
    );
  }
}
