import 'package:flutter/material.dart';
import 'package:ui_sdk/components/UikAvatar.dart';
import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import '../props/UikProfileProps.dart';

class UikProfile extends UikWidget{
  WidgetType _widgetType;
  UikProfileProps _uikProfileProps;
  UikProfile(this._widgetType, this._uikProfileProps)
      : super(_widgetType, _uikProfileProps);
  @override
  _UikProfileState createState() =>
      _UikProfileState(_uikProfileProps);
}

class _UikProfileState extends State<UikProfile> {
  UikProfileProps _uikProfileProps;
  _UikProfileState(this._uikProfileProps);

  @override
  Widget build(BuildContext context) {
    return Container(
      margin: EdgeInsets.fromLTRB(_uikProfileProps.leftMargin, _uikProfileProps.topMargin, _uikProfileProps.rightMargin, _uikProfileProps.bottomMargin),
      child: Row(
        children: [
          _uikProfileProps.circularAvatar,
          SizedBox(width: 16,),
          Column(
            crossAxisAlignment: CrossAxisAlignment.start,
            children: [
              _uikProfileProps.title,
              SizedBox(height:3,),
              _uikProfileProps.subtitle,
            ],
          )
        ],
      ),
    );
  }
}
