import 'package:ui_sdk/components/UikWidget.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:flutter/material.dart';

import '../props/UikTopBarProps.dart';

class UikTopBar extends UikWidget {
  WidgetType _widgetType;
  UikTopBarProps _uikTopBarProps;
  UikTopBar(this._widgetType, this._uikTopBarProps)
      : super(_widgetType, _uikTopBarProps);

  @override
  _UikTopBarState createState() => _UikTopBarState(_uikTopBarProps);
}

class _UikTopBarState extends State<UikTopBar> {
  UikTopBarProps _uikTopBarProps;
  _UikTopBarState(this._uikTopBarProps);

  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: EdgeInsets.only(
        top: _uikTopBarProps.topPadding,
        bottom: _uikTopBarProps.bottomPadding,
        left: _uikTopBarProps.leftPadding,
        right: _uikTopBarProps.rightPadding,
      ),
      child: Row(
        mainAxisAlignment: MainAxisAlignment.spaceBetween,
        children: [
          _uikTopBarProps.icon,
          _uikTopBarProps.text,
          /* ...List.generate(
            _uikTopBarProps.children.length,
            (index) => _uikTopBarProps.children[index],
          ), */
        ],
      ),
    );
  }
}
