import 'dart:ui';
// import 'package:ui_sdk/datastores/order.dart';
import 'package:ui_sdk/convertorFunctions/order.dart';
import 'package:ui_sdk/models/emptyCatalog.dart';
import 'package:ui_sdk/models/emptyOrder.dart';
import 'package:ui_sdk/models/emptyPlan.dart';
import 'package:ui_sdk/models/emptySdkObject.dart';
import 'package:ui_sdk/models/emptyWidgetObject.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:intl/intl.dart';

Map<String, dynamic> catalogConvertor(dynamic body) {
  // STEPS:
  // (1) extract the values from body of response
  // (2) generate an empty object for that component
  // (3) inserting that empty component into the datastore
  // (4) generate an empty widget object {id,uiType}
  // (5) inserting the emptywidget object in orderWidget for rendering

  // print("janvi");

  var obj2 = Grid();
  var dummyGrid = obj2.emptyGrid;

  int numberOfItems = (body["products"] as List).length;

  // -------------- GRID
  for (int i = 0; i < numberOfItems; i++) {
    // print(i);
    var obj = ProductCardBig();
    var dummyCard = obj.emptyProductCardBig;
    String imgUrl = body["products"][i]["media"]["mainMedia"]["image"]["url"];
    double price = body["products"][i]["price"]["price"];
    String description = body["products"][i]["description"];
    String? tag = body["products"][i]["ribbon"];
    if (tag != "") {
      dummyCard["isBadge"] = true;
      (dummyCard["badge"]! as Map)["text"] = tag;
    }

    dummyCard["imageUrl"] = imgUrl;
    dummyCard["productPrice"] = price.toString();
    dummyCard["productDescription"] = description;

    (dummyGrid["productCards"] as List).add(dummyCard);
  }

  // ------------------- GRID 2
  // for (int i = (numberOfItems / 2) as int; i < numberOfItems; i++) {
  //   print(i);
  //   var obj = ProductCardBig();
  //   var dummyCard = obj.emptyProductCardBig;
  //   String imgUrl = body["products"][i]["media"]["mainMedia"]["image"]["url"];
  //   // print(imgUrl);
  //   double price = body["products"][i]["price"]["price"];
  //   // print(price);
  //   String description = body["products"][i]["description"];
  //   // print(description);
  //   String? tag = body["products"][i]["ribbon"];

  //   // print(tag);
  //   if (tag != "") {
  //     dummyCard["isBadge"] = true;
  //     (dummyCard["badge"]! as Map)["text"] = tag;
  //   }

  //   dummyCard["imageUrl"] = imgUrl;
  //   dummyCard["productPrice"] = price.toString();
  //   dummyCard["productDescription"] = description;

  //   (dummyGrid2["productCards"] as List).add(dummyCard);
  // }
  // print(dummyGrid2);
  // int length = (emptyGrid["productCards"] as List).length;
  // print(length);

  catalogDatastore["titleGrid"] = dummyGrid;
  emptyWidgetObject["id"] = "titleGrid";
  emptyWidgetObject["uiType"] = "UikProductCardGrid";
  catalogWidget.insert(3, emptyWidgetObject);
  // print(catalogWidget);

  emptySdkObject["widgets"] = catalogWidget;
  emptySdkObject["dataStore"] = catalogDatastore;

  return emptySdkObject;
}

var catalogDatastore = {
  // ------------------------------navigation bar
  "titleNavbar": {
    "id": "titleNavbar",
    "size": "small",
    "transparency": "false",
    "backgroundColor": "0xFFFAFAFA",
    "titleText": "Furniture",
    "leftIcon": {
      "id": "titleIcon",
      "iconVal": "0xee85",
      "iconColor": "0xFF212121",
      "borderColor": "0xFF212121",
      "backgroundColor": "0xFF9E9E9E",
      "iconSize": "24.0",
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {
            "url":
                "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
          }
        }
      }
    },
    "triggerElementType": "icon",
    "triggerIcon": {
      "id": "titleIcon",
      "iconVal": "0xf37f",
      "iconColor": "0xFF212121",
      "borderColor": "0xFF212121",
      "backgroundColor": "0xFF9E9E9E",
      "iconSize": "24.0",
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {
            "url":
                "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
          }
        }
      }
    },
    "action": {
      "tap": {
        "type": "UIK_OPEN_WEB",
        "data": {
          "url":
              "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
        }
      }
    }
  },
  // ------------------------------search bar datastore
  "titleSearch": {
    "id": "titleSearch",
    "label": "Search",
    "frontSearchIcon": {
      "id": "titleIcon",
      "iconVal": "0xe567",
      "iconColor": "0xFF9E9E9E",
      "backgroundColor": "0xFFF5F5F5",
      "padding": "0.0",
      "iconSize": "23.0",
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {
            "url":
                "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
          }
        }
      }
    },
    "text": "Headlines",
    "micIcon": "false",
    "borderColor": "0xFFF5F5F5",
    "action": {
      "tap": {
        "type": "UIK_OPEN_WEB",
        "data": {
          "url":
              "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
        }
      }
    }
  },

  // -------------------------------sort-filter datastore
  "titleSortFilter": {
    "id": "titleSortFilter",
    "sortButton": {
      "id": "sortButton",
      "type": "primary",
      "text": "Sort",
      "leftMargin": 16,
      "rightMargin": 7.5,
      "textWeight": "FontWeight.w500",
      "backgroundColor": "0XFFF5F5F5",
      "borderColor": "0XFFF5F5F5",
      "textSize": "14.0",
      "widthSize": "164",
      "heightSize": "36",
      "rightElement": {
        "id": "titleIcon",
        "iconVal": "0xe5d2",
        "iconColor": "0xFF212121",
        "backgroundColor": "0xFF212121",
        "iconSize": "15.0",
        "action": {
          "tap": {
            "type": "UIK_OPEN_WEB",
            "data": {
              "url":
                  "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
            }
          }
        }
      },
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {"url": "https://www.tesla.com/"}
        }
      }
    },
    "filterButton": {
      "id": "filterButton",
      "type": "primary",
      "text": "Filter",
      "leftMargin": 7.5,
      "rightMargin": 16,
      "backgroundColor": "0XFFF5F5F5",
      "borderColor": "0XFFF5F5F5",
      "textSize": "14.0",
      "widthSize": "164",
      "heightSize": "36",
      "textWeight": "FontWeight.w500",
      "rightElement": {
        "id": "titleIcon",
        "iconVal": "0xe280",
        "iconColor": "0xFF212121",
        "backgroundColor": "0xFF212121",
        "iconSize": "15.0",
        "action": {
          "tap": {
            "type": "UIK_OPEN_WEB",
            "data": {
              "url":
                  "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
            }
          }
        }
      },
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {"url": "https://www.tesla.com/"}
        }
      }
    }
  },
};

var catalogWidget = [
  {"id": "titleNavbar", "uiType": "UikNavbar"},
  {"id": "titleSearch", "uiType": "UikSearch"},
  {"id": "titleSortFilter", "uiType": "UikSortFilter"}
];
