import 'dart:ui';
// import 'package:ui_sdk/datastores/order.dart';
import 'package:ui_sdk/models/emptyOrder.dart';
import 'package:ui_sdk/models/emptySdkObject.dart';
import 'package:ui_sdk/models/emptyWidgetObject.dart';
import 'package:date_format/date_format.dart';

import 'package:intl/intl.dart';

Map<String, dynamic> orderConvertor(dynamic body) {
  // STEPS:
  // (1) extract the values from body of response
  // (2) generate an empty object for that component
  // (3) inserting that empty component into the datastore
  // (4) generate an empty widget object {id,uiType}
  // (5) inserting the emptywidget object in orderWidget for rendering

// -------------- NAVIGATION BAR ------------------//
  int orderNumber = body['order']['number'];
  emptyNavbar["titleText"] = "Order #" + orderNumber.toString();
  orderDataStore["navbar"] = emptyNavbar;
  emptyWidgetObject1["id"] = "navbar";
  emptyWidgetObject1["uiType"] = "UikNavbar";
  orderWidget.insert(0, emptyWidgetObject1);

  // ----------- TIME DETAILS --------------------//
  String dateTime = body['order']['dateCreated'];
  DateTime parseDt = DateTime.parse(dateTime);
  var day = DateFormat.EEEE().format(parseDt);
  var time = DateFormat.jm().format(parseDt);
  String dayTime = day.toString() + ', ' + time.toString();

  emptyHeadline1["text"] = dayTime;
  orderDataStore["headline1"] = emptyHeadline1;
  emptyWidgetObject2["id"] = "headline1";
  emptyWidgetObject2["uiType"] = "UikText";
  orderWidget.insert(1, emptyWidgetObject2);

  // ------------ PAYMENT STATUS ----------------//
  String paymentStatus = body['order']['paymentStatus'];
  if (paymentStatus == "NOT_PAID") {
    emptyHeadline2["text"] = "Waiting for payment";
  } else {
    emptyHeadline2["text"] = "Payment completed";
  }
  orderDataStore["headline2"] = emptyHeadline2;
  emptyWidgetObject3["id"] = "headline2";
  emptyWidgetObject3["uiType"] = "UikText";
  // print(emptyWidgetObject);
  orderWidget.insert(2, emptyWidgetObject3);
  // print(orderWidget);

  // --------------------- PRODUCT CARDS--------------------//
  int numberOfItems = body['order']['lineItems'].length;
  int count = 2;
  for (int i = 0; i < numberOfItems; i++) {
    //extracting fields from the body
    String imageUrl = body['order']['lineItems'][i]['mediaItem']['url'];
    String price = body['order']['lineItems'][i]['price'];
    String name = body['order']['lineItems'][i]['name'];

    //generating emptyProductCard
    emptyProductCard["productPrice"] = '\$' + price;
    emptyProductCard["imageUrl"] = imageUrl;
    emptyProductCard["productDescription"] = name;

    //inserting Emptyproductcard in datastore
    orderDataStore["ProductCard${i}"] = emptyProductCard;

    emptyWidgetObject4["id"] = "ProductCard${i}";
    emptyWidgetObject4["uiType"] = "UikProductCard";

    count++;
    orderWidget.insert(count, emptyWidgetObject4);
  }

  //delivery info and status
  String currStatus = body['order']['activities'][0]['type'];
  currStatus = currStatus.toLowerCase();
  currStatus = currStatus.replaceAll('_', ' ');
  dynamic obj = emptyCell["rightElement"];
  if (obj != null) {
    obj["text"] = currStatus;
  }

  orderDataStore["cell0"] = emptyCell;
  emptyWidgetObject7["id"] = "cell0";
  emptyWidgetObject7["uiType"] = "UikCell";
  orderWidget.insert(4, emptyWidgetObject7);

  // ---------- delivery mode -------------//
  String deliveryMode = body['order']['shippingInfo']['deliveryOption'];
  obj = emptyCell1["titleText"];
  if (obj != null) {
    obj["text"] = deliveryMode;
  }
  orderDataStore["cell1"] = emptyCell1;
  emptyWidgetObject5["id"] = "cell1";
  emptyWidgetObject5["uiType"] = "UikCell";
  orderWidget.insert(5, emptyWidgetObject5);

  // -----------delivery address and name-------------//
  String addressLine1 = body['order']['shippingInfo']['shipmentDetails']
      ['address']['addressLine1'];
  String city =
      body['order']['shippingInfo']['shipmentDetails']['address']['city'];
  String firstName = body['order']['shippingInfo']['shipmentDetails']['address']
      ['fullName']['firstName'];
  String lastName = body['order']['shippingInfo']['shipmentDetails']['address']
      ['fullName']['lastName'];
  String phone =
      body['order']['shippingInfo']['shipmentDetails']['address']['phone'];

  obj = emptyCell2["titleText"];
  if (obj != null) {
    obj["text"] = city + ', ' + addressLine1;
  }

  obj = emptyCell2["subtitleText"];
  if (obj != null) {
    obj["text"] = firstName + ' ' + lastName + ', ' + phone;
  }

  orderDataStore["cell2"] = emptyCell2;
  emptyWidgetObject6["id"] = "cell2";
  emptyWidgetObject6["uiType"] = "UikCell";
  orderWidget.insert(6, emptyWidgetObject6);

  emptySdkObject["widgets"] = orderWidget;
  emptySdkObject["dataStore"] = orderDataStore;
  // print("janvi 1");

  return emptySdkObject;
}

var orderDataStore = {};

var orderWidget = [];
