import 'package:ui_sdk/models/emptySdkObject.dart';
import 'package:html/parser.dart';

Map<String, dynamic> productDetailPage(dynamic body) {
  // setting up the description
  final htmlString = body['products']['items'][0]['description']['html'];
  final description = _parseHtmlString(htmlString);
  (datastore['ProductPageContainer']!['desc'] as Map)['text'] = description;
  print(datastore['ProductPageContainer']!['desc']);

  //setting up the price
  final price = body['products']['items'][0]['price_range']['minimum_price']
      ['regular_price']['value'];
  print(price);
  (datastore['ProductPageContainer']!['price'] as Map)['text'] = price;

  emptySdkObject["widgets"] = widgetsArray;
  emptySdkObject["dataStore"] = datastore;
  return emptySdkObject;
}

String _parseHtmlString(String htmlString) {
  final document = parse(htmlString);
  final String parsedString = parse(document.body!.text).documentElement!.text;

  return parsedString;
}

var datastore = {
  "Pagination": {
    "id": "Pagination",
    "iconList": [
      {
        "id": "Icon1",
        "iconVal": "0xe793",
        "iconSize": "30.0",
        "wid": "3.5",
        "rad": "30.0",
        "backgroundColor": "0xFFBCB9B8",
        "borderColor": "0xFFBC9B8"
      },
      {
        "id": "Icon2",
        "iconVal": "0xf37f",
        "iconSize": "30.0",
        "wid": "3.5",
        "rad": "30.0",
        "backgroundColor": "0xFFBCB9B8",
        "borderColor": "0xFFBC9B8"
      },
      {
        "id": "Icon3",
        "iconVal": "0xe25c",
        "iconSize": "30.0",
        "wid": "3.5",
        "rad": "30.0",
        "backgroundColor": "0xFFBCB9B8",
        "borderColor": "0xFFBC9B8"
      }
    ],
    "imgList": [
      {
        "id": "Img",
        "src":
            "https://lh3.googleusercontent.com/2hDpuTi-0AMKvoZJGd-yKWvK4tKdQr_kLIpB_qSeMau2TNGCNidAosMEvrEXFO9G6tmlFlPQplpwiqirgrIPWnCKMvElaYgI-HiVvXc=w600",
        "height": "108.0",
        "width": "192.0",
        "rad": "5.0",
        "iFit": "BoxFit.contain"
      },
      {
        "id": "Img",
        "src":
            "https://media.moddb.com/cache/images/members/5/4550/4549205/thumb_620x2000/duck.jpg",
        "height": "108.0",
        "width": "192.0",
        "rad": "5.0",
        "iFit": "BoxFit.contain"
      },
      {
        "id": "Img",
        "src":
            "https://stickerly.pstatic.net/sticker_pack/PQEbA06NLcQ7reKUeFtK0g/9I87N5/2/08cebe44-befc-4883-b0a8-913d0225db72.png",
        "height": "108.0",
        "width": "192.0",
        "rad": "5.0",
        "iFit": "BoxFit.contain"
      }
    ],
    "action": {
      "tap": {
        "type": "UIK_OPEN_WEB",
        "data": {
          "url":
              "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
        }
      }
    }
  },
  "ProductPageContainer": {
    "id": "ProductPageContainer",
    "tagRow": {
      "id": "titleProductScreenTagsRow",
      "array": [
        {
          "id": "Tag1",
          "width": "100.0",
          "height": "50.0",
          "text": {
            "id": "titleText",
            "text": "Brown",
            "color": "0xFFFFFFFF",
            "fontFamily": "Poppins",
            "action": {
              "tap": {
                "type": "UIK_OPEN_WEB",
                "data": {
                  "url":
                      "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
                }
              }
            }
          },
          "backgroundColor": "0xFF212121",
          "avatar": {
            "id": "titleAvatar",
            "backgroundColor": "0xFFA56506",
            "shape": "BoxShape.circle",
            "width": "18.0",
            "height": "18.0",
            "action": {
              "tap": {
                "type": "UIK_OPEN_WEB",
                "data": {
                  "url":
                      "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
                }
              }
            }
          },
          "action": {
            "tap": {
              "type": "UIK_OPEN_WEB",
              "data": {"url": "https://www.tesla.com/"}
            }
          }
        },
        {
          "id": "Tag2",
          "width": "100.0",
          "height": "50.0",
          "text": {
            "id": "titleText",
            "text": "Black",
            "fontFamily": "Poppins",
            "action": {
              "tap": {
                "type": "UIK_OPEN_WEB",
                "data": {
                  "url":
                      "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
                }
              }
            }
          },
          "backgroundColor": "0xFFF5F5F5",
          "textColor": "0xFF212121",
          "avatar": {
            "id": "titleAvatar",
            "backgroundColor": "0xFF000000",
            "shape": "BoxShape.circle",
            "width": "18.0",
            "height": "18.0",
            "action": {
              "tap": {
                "type": "UIK_OPEN_WEB",
                "data": {
                  "url":
                      "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
                }
              }
            }
          },
          "action": {
            "tap": {
              "type": "UIK_OPEN_WEB",
              "data": {"url": "https://www.tesla.com/"}
            }
          }
        }
      ],
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {"url": "https://www.tesla.com/"}
        }
      }
    },
    "addCartButton": {
      "id": "titleAddToCartButton",
      "text": {
        "id": "CartButton",
        "text": "Add to Bag",
        "fontFamily": "Poppins"
      },
      "widthSize": "30.0",
      "heightSize": "64.0",
      "leftMargin": "15.0",
      "rightMargin": "15.0",
      "rightElement": {"id": "Icon", "iconVal": "0xf37d", "iconSize": "25.0"},
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {"url": "https://www.tesla.com/"}
        }
      }
    },
    "price": {
      "id": "titleText2",
      "text": "150.00",
      "leftMargin": "36.0",
      "topMargin": "44.0",
      "width": "93.0",
      "height": "32.0",
      "size": "24.0",
      "fontWeight": "FontWeight.w600",
      "fontFamily": "Poppins",
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {
            "url":
                "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
          }
        }
      }
    },
    "desc": {
      "id": "titleText3",
      "text": "Wooden bedside table featuring a raised design on the door",
      "leftMargin": "16.0",
      "rightMargin": "16.0",
      "topMargin": "60.0",
      "bottomMargin": "112.0",
      "size": "16.0",
      "width": "343.0",
      "height": "48.0",
      "fontWeight": "FontWeight.w400",
      "fontFamily": "Poppins",
      "color": "0xFF9E9E9E",
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {
            "url":
                "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
          }
        }
      }
    },
    "action": {
      "tap": {
        "type": "UIK_OPEN_WEB",
        "data": {
          "url":
              "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
        }
      }
    }
  },
  "Discount": {
    "id": "Discount",
    "topMargin": "20.0",
    "bottomMargin": "20.0",
    "icon": {"id": "UikIcon", "iconVal": "0xf0451", "iconSize": "30.0"},
    "button": {
      "id": "CopyButton",
      "text": {"id": "CartButton", "text": "Copy", "fontFamily": "Poppins"},
      "widthSize": "290.0",
      "heightSize": "50.0",
      "topMargin": "15.0",
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {"url": "https://www.tesla.com/"}
        }
      }
    },
    "sideMargin": "20.0",
    "centerText1": {
      "id": "UikText",
      "text": "Discount for you",
      "size": "16.0",
      "fontWeight": "FontWeight.w400",
      "fontFamily": "Poppins",
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {
            "url":
                "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
          }
        }
      }
    },
    "centerText2": {
      "id": "UikText",
      "text": "Use promocode ULMO",
      "size": "16.0",
      "fontWeight": "FontWeight.w200",
      "fontFamily": "Poppins",
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {
            "url":
                "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
          }
        }
      }
    },
    "action": {
      "tap": {
        "type": "UIK_OPEN_WEB",
        "data": {
          "url":
              "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
        }
      }
    }
  },
  "ProductPageInformationContainer": {
    "id": "ProductPageInformationContainer",
    "text1": {
      "id": "UikText",
      "text": "Product Information",
      "fontFamily": "Poppins",
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {
            "url":
                "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
          }
        }
      }
    },
    "text2": {
      "id": "UikText",
      "text": "Reviews",
      "fontFamily": "Poppins",
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {
            "url":
                "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
          }
        }
      }
    },
    "text3": {
      "id": "UikText",
      "text": "Questions and Answers",
      "fontFamily": "Poppins",
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {
            "url":
                "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
          }
        }
      }
    },
    "action": {
      "tap": {
        "type": "UIK_OPEN_WEB",
        "data": {
          "url":
              "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
        }
      }
    }
  },
  "LikeText": {
    "id": "UikText",
    "text": "You might also like",
    "color": "0xFF000000",
    "width": "343",
    "height": "32",
    "size": "24.0",
    "leftMargin": "20.0",
    "rightMargin": "20.0",
    "topMargin": "0.0",
    "bottomMargin": "0.0",
    "fontWeight": "FontWeight.w400",
    "fontFamily": "Poppins",
    "action": {
      "tap": {
        "type": "UIK_OPEN_WEB",
        "data": {
          "url":
              "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
        }
      }
    }
  },
  "ProductCardGrid": {
    "id": "ProductCardGrid",
    "productCards": [
      {
        "id": "ProductCard",
        "imageUrl":
            "https://lh3.googleusercontent.com/2hDpuTi-0AMKvoZJGd-yKWvK4tKdQr_kLIpB_qSeMau2TNGCNidAosMEvrEXFO9G6tmlFlPQplpwiqirgrIPWnCKMvElaYgI-HiVvXc=w600",
        "productDescription":
            "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer consectetur, libero ac pulvinar dignissim, ex eros rutrum massa, non ornare elit magna quis sem.",
        "favIcon": {
          "id": "Icon1",
          "iconVal": "0xe25c",
          "iconSize": "22.0",
          "wid": "3.5",
          "rad": "30.0"
        },
        "productPrice": "420.69",
        "action": {
          "tap": {
            "type": "UIK_OPEN_WEB",
            "data": {
              "url":
                  "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
            }
          }
        }
      },
      {
        "id": "ProductCard",
        "imageUrl":
            "https://lh3.googleusercontent.com/2hDpuTi-0AMKvoZJGd-yKWvK4tKdQr_kLIpB_qSeMau2TNGCNidAosMEvrEXFO9G6tmlFlPQplpwiqirgrIPWnCKMvElaYgI-HiVvXc=w600",
        "productDescription":
            "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer consectetur, libero ac pulvinar dignissim, ex eros rutrum massa, non ornare elit magna quis sem.",
        "favIcon": {
          "id": "Icon1",
          "iconVal": "0xe25c",
          "iconSize": "22.0",
          "wid": "3.5",
          "rad": "30.0"
        },
        "productPrice": "420.69",
        "action": {
          "tap": {
            "type": "UIK_OPEN_WEB",
            "data": {
              "url":
                  "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
            }
          }
        }
      },
      {
        "id": "ProductCard",
        "imageUrl":
            "https://media.moddb.com/cache/images/members/5/4550/4549205/thumb_620x2000/duck.jpg",
        "productDescription":
            "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer consectetur, libero ac pulvinar dignissim, ex eros rutrum massa, non ornare elit magna quis sem.",
        "favIcon": {
          "id": "Icon1",
          "iconVal": "0xe25c",
          "iconSize": "22.0",
          "wid": "3.5",
          "rad": "30.0"
        },
        "productPrice": "420.69",
        "action": {
          "tap": {
            "type": "UIK_OPEN_WEB",
            "data": {
              "url":
                  "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
            }
          }
        }
      },
      {
        "id": "ProductCard",
        "imageUrl":
            "https://media.moddb.com/cache/images/members/5/4550/4549205/thumb_620x2000/duck.jpg",
        "productDescription":
            "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer consectetur, libero ac pulvinar dignissim, ex eros rutrum massa, non ornare elit magna quis sem.",
        "favIcon": {
          "id": "Icon1",
          "iconVal": "0xe25c",
          "iconSize": "22.0",
          "wid": "3.5",
          "rad": "30.0"
        },
        "productPrice": "420.69",
        "action": {
          "tap": {
            "type": "UIK_OPEN_WEB",
            "data": {
              "url":
                  "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
            }
          }
        }
      },
      {
        "id": "ProductCard",
        "imageUrl":
            "https://stickerly.pstatic.net/sticker_pack/PQEbA06NLcQ7reKUeFtK0g/9I87N5/2/08cebe44-befc-4883-b0a8-913d0225db72.png",
        "productDescription":
            "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer consectetur, libero ac pulvinar dignissim, ex eros rutrum massa, non ornare elit magna quis sem.",
        "favIcon": {
          "id": "Icon1",
          "iconVal": "0xe25c",
          "iconSize": "22.0",
          "wid": "3.5",
          "rad": "30.0"
        },
        "productPrice": "420.69",
        "action": {
          "tap": {
            "type": "UIK_OPEN_WEB",
            "data": {
              "url":
                  "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
            }
          }
        }
      },
      {
        "id": "ProductCard",
        "imageUrl":
            "https://stickerly.pstatic.net/sticker_pack/PQEbA06NLcQ7reKUeFtK0g/9I87N5/2/08cebe44-befc-4883-b0a8-913d0225db72.png",
        "productDescription":
            "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer consectetur, libero ac pulvinar dignissim, ex eros rutrum massa, non ornare elit magna quis sem.",
        "favIcon": {
          "id": "Icon1",
          "iconVal": "0xe25c",
          "iconSize": "22.0",
          "wid": "3.5",
          "rad": "30.0"
        },
        "productPrice": "420.69",
        "action": {
          "tap": {
            "type": "UIK_OPEN_WEB",
            "data": {
              "url":
                  "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
            }
          }
        }
      }
    ],
    "leftPadding": "20.0",
    "gridWidth": "410",
    "action": {
      "tap": {
        "type": "UIK_OPEN_WEB",
        "data": {
          "url":
              "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
        }
      }
    }
  }
};

var widgetsArray = [
  {"id": "Pagination", "uiType": "UikPagination"},
  {"id": "ProductPageContainer", "uiType": "UikProductPageContainer"},
  {"id": "Discount", "uiType": "UikDiscount"},
  {
    "id": "ProductPageInformationContainer",
    "uiType": "UikProductPageInformationContainer"
  },
  {"id": "LikeText", "uiType": "UikContainerText"},
  {"id": "ProductCardGrid", "uiType": "UikProductCardGrid"}
];
