
import 'package:ui_sdk/models/emptySdkObject.dart';
import 'package:ui_sdk/models/emptyTagObject.dart';

Map<String, dynamic> productPageConvertor(dynamic body) {
  int lengthOfChoices = body["product"]["productOptions"][0]["choices"].length;
  (datastore["titleProductPageContainer"]!["desc"] as Map)["text"] = body['product']['description'];
  (datastore["titleProductPageContainer"]!["price"] as Map)["text"] = body['product']['price']['formatted']['price'];
  for(int i=0;i<lengthOfChoices;i++) {
    String value = body["product"]["productOptions"][0]["choices"][i]["value"];
    String desc = body["product"]["productOptions"][0]["choices"][i]["description"];
    var obj = pair();
    var dummyTag = obj.emptyTagObject;
    dummyTag["text"] = desc;
    if(value.length != 7) {
      int length = value.length;
      for(int j=0;j<7-length;j++) {
        value += "0";
      }
    }
    (dummyTag["avatar"] as Map)["backgroundColor"] = "0xFF" + value.substring(1);
    (datastore["titleProductPageContainer"]!["tagRow"] as Map)["array"].addAll({dummyTag});
  }
  emptySdkObject["widgets"] = widgetsArray;
  emptySdkObject["dataStore"] = datastore;
  return emptySdkObject;
}

var datastore = {
  "titleProductPageInformationContainer": {
    "id": "titleProductPageInformationContainer",
    "action": {
      "tap": {
        "type": "UIK_OPEN_WEB",
        "data": {
          "url":
              "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
        }
      }
    }
  },
  "titleProductPageContainer": {
    "id": "titleProductPageContainer",
    "tagRow": {
      "id": "titleProductScreenTagsRow",
      "array": [],
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {"url": "https://www.tesla.com/"}
        }
      }
    },
    "addCartButton": {
      "id": "titleAddToCartButton",
      "text": "Add to bag",
      "widthSize": "343.0",
      "heightSize": "64.0",
      "leftMargin": "16.0",
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {"url": "https://www.tesla.com/"}
        }
      }
    },
    "price": {
      "id": "titleText2",
      "text": "\$150.00",
      "leftMargin": "16.0",
      "topMargin": "24.0",
      "width": "93.0",
      "height": "32.0",
      "size": "24.0",
      "fontWeight": "FontWeight.w600",
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {
            "url":
                "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
          }
        }
      }
    },
    "desc": {
      "id": "titleText3",
      "text": "Wooden bedside table featuring a raised design on the door",
      "leftMargin": "16.0",
      "rightMargin": "16.0",
      "topMargin": "4.0",
      "bottomMargin": "24.0",
      "size": "16.0",
      "width": "343.0",
      "height": "48.0",
      "fontWeight": "FontWeight.w400",
      "color": "0xFF9E9E9E",
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {
            "url":
                "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
          }
        }
      }
    },
    "action": {
      "tap": {
        "type": "UIK_OPEN_WEB",
        "data": {
          "url":
              "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
        }
      }
    }
  },
  "titleProductPagePagination": {
    "id": "titleProductPagePagination",
    "image": {
      "id": "titleImage",
      "src":
          "https://images.pexels.com/photos/213780/pexels-photo-213780.jpeg?auto=compress&cs=tinysrgb&dpr=1&w=500",
      "iFit": "BoxFit.fill",
      "width": "375.0",
      "height": "458.0",
      "action": {
        "tap": {
          "type": "UIK_OPEN_WEB",
          "data": {
            "url":
                "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
          }
        }
      }
    },
    "action": {
      "tap": {
        "type": "UIK_OPEN_WEB",
        "data": {
          "url":
              "https://sylhetmirror.com/2022/04/03/tesla-delivers-over-1-million-electric-cars-over-past-year/"
        }
      }
    }
  }
};

var widgetsArray = [
  {"id": "titleProductPagePagination", "uiType": "UikProductPagePagination"},
  {"id": "titleProductPageContainer", "uiType": "UikProductPageContainer"},
  {
    "id": "titleProductPageInformationContainer",
    "uiType": "UikProductPageInformationContainer"
  }
];
