import 'package:ui_sdk/components/UikIcon.dart';
import 'package:ui_sdk/components/UikImage.dart';
import 'package:ui_sdk/components/UikTags.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/props/UikImageProps.dart';
import 'package:ui_sdk/props/UikTagsProps.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:flutter/material.dart';

import '../../components/UikButton.dart';
import '../../components/UikText.dart';
import '../../components/WidgetType.dart';
import '../../props/UikDropDownProps.dart';

UikDropDownProps $UikDropDownPropsFromJson(Map<String, dynamic> json) {
  final UikDropDownProps uikHomeCardElevenProps = UikDropDownProps();

  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikHomeCardElevenProps.id = id;
  }

  final double? leftMargin = jsonConvert.convert<double>(json['leftMargin']);
  if (leftMargin != null) {
    uikHomeCardElevenProps.leftMargin = leftMargin;
  }

  final double? rightMargin = jsonConvert.convert<double>(json['rightMargin']);
  if (rightMargin != null) {
    uikHomeCardElevenProps.rightMargin = rightMargin;
  }

  final double? topMargin = jsonConvert.convert<double>(json['topMargin']);
  if (topMargin != null) {
    uikHomeCardElevenProps.topMargin = topMargin;
  }

  final double? bottomMargin =
      jsonConvert.convert<double>(json['bottomMargin']);
  if (bottomMargin != null) {
    uikHomeCardElevenProps.bottomMargin = bottomMargin;
  }

  final String? text = jsonConvert.convert<String>(json['text']);
  if (text != null) {
    uikHomeCardElevenProps.text = text;
  }

  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikHomeCardElevenProps.action = action;
  }
  return uikHomeCardElevenProps;
}
