import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikTextProps.dart';
import 'package:ui_sdk/utils/extensions.dart';
import '../../components/UikText.dart';
import '../../components/WidgetType.dart';
import '../../props/UikAvatarProps.dart';

UikAvatarProps $UikAvatarPropsFromJson(Map<String, dynamic> json) {
  final UikAvatarProps uikAvatarProps = UikAvatarProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikAvatarProps.id = id;
  }
  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikAvatarProps.action = action;
  }
  final String? backgroundImage =
      jsonConvert.convert<String>(json['backgroundImage']);
  if (backgroundImage != null) {
    uikAvatarProps.backgroundImage = backgroundImage;
  }

  final String? backgroundColor =
      jsonConvert.convert<String>(json['backgroundColor']);
  if (backgroundColor != null) {
    uikAvatarProps.backgroundColor = backgroundColor.toColor();
  }

  final double? radius = jsonConvert.convert<double>(json['radius']);
  if (radius != null) {
    uikAvatarProps.radius = radius;
  }

  final String? text = jsonConvert.convert<String>(json['text']);
  if (text != null) {
    uikAvatarProps.text =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['text']));
  }

  return uikAvatarProps;
}
