import 'package:ui_sdk/components/UikIcon.dart';
import 'package:ui_sdk/components/UikText.dart';
import 'package:ui_sdk/components/WidgetType.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikIconProps.dart';
import 'package:ui_sdk/props/UikIconTextProps.dart';
import 'package:ui_sdk/props/UikTextProps.dart';

UikIconTextProps $UikIconTextPropsFromJson(Map<String, dynamic> json) {
  final UikIconTextProps uikIconTextProps = UikIconTextProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikIconTextProps.id = id;
  }
  final String? icon = jsonConvert.convert<String>(json['icon']);
  if (icon != null) {
    uikIconTextProps.icon =
        UikIcon(WidgetType.UikText, UikIconProps.fromJson(json['icon']));
  }
  final String? title = jsonConvert.convert<String>(json['title']);
  if (title != null) {
    uikIconTextProps.title =
        UikText(WidgetType.UikText, UikTextProps.fromJson(json['title']));
  }
  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikIconTextProps.action = action;
  }
  final double? leftMargin = jsonConvert.convert<double>(json['leftMargin']);
  if (leftMargin != null) {
    uikIconTextProps.leftMargin = leftMargin;
  }
  final double? topMargin = jsonConvert.convert<double>(json['topMargin']);
  if (topMargin != null) {
    uikIconTextProps.topMargin = topMargin;
  }
  final double? rightMargin = jsonConvert.convert<double>(json['rightMargin']);
  if (rightMargin != null) {
    uikIconTextProps.rightMargin = rightMargin;
  }

  final double? distance = jsonConvert.convert<double>(json["distance"]);
  if (distance != null) {
    uikIconTextProps.distance = distance;
  }

  final double? bottomMargin =
      jsonConvert.convert<double>(json['bottomMargin']);
  if (bottomMargin != null) {
    uikIconTextProps.bottomMargin = bottomMargin;
  }
  return uikIconTextProps;
}

Map<String, dynamic> $UikIconTextPropsToJson(UikIconTextProps entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['id'] = entity.id;
  // data['action'] = entity.action.toJson();
  return data;
}
