import 'dart:ui';

import 'package:ui_sdk/components/UikColumn.dart';
import 'package:ui_sdk/components/UikImage.dart';
import 'package:ui_sdk/components/UikListTile.dart';
import 'package:ui_sdk/components/UikProductCardGrid.dart';
import 'package:ui_sdk/components/UikSearch.dart';
import 'package:ui_sdk/components/UikStepper.dart';
import 'package:ui_sdk/components/UikThreeComponentRow.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/generated/json/base/json_convert_content.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:ui_sdk/props/UikButtonProps.dart';
import 'package:ui_sdk/props/UikImageProps.dart';
import 'package:ui_sdk/props/UikProductCardGridProps.dart';
import 'package:ui_sdk/utils/extensions.dart';

import '../../components/UikButton.dart';
import '../../components/UikCell.dart';
import '../../components/UikChips.dart';
import '../../components/UikContainerText.dart';
import '../../components/UikIcon.dart';
import '../../components/UikListTiles.dart';
import '../../components/UikRadioButton.dart';
import '../../components/UikText.dart';
import '../../components/WidgetType.dart';
import '../../components/uikTextChip.dart';
import '../../props/UikCellProps.dart';
import '../../props/UikChipsProps.dart';
import '../../props/UikColumnProps.dart';
import '../../props/UikContainerTextProps.dart';
import '../../props/UikIconProps.dart';

import '../../components/UikIcon.dart';
import '../../components/WidgetType.dart';
import '../../props/UikIconProps.dart';
import '../../props/UikListTileProps.dart';
import '../../props/UikListTilesProps.dart';
import '../../props/UikRadioButtonProps.dart';
import '../../props/UikSearchProps.dart';
import '../../props/UikStepperProps.dart';
import '../../props/UikTextChipProps.dart';
import '../../props/UikTextProps.dart';
import '../../props/UikThreeComponentRowProps.dart';
import '../../props/UikTwoComponentRowProps.dart';

UikTwoComponentRowProps $UikTwoComponentRowPropsFromJson(
    Map<String, dynamic> json) {
  print("entering here");
  final UikTwoComponentRowProps uikTwoComponentRowProps =
      UikTwoComponentRowProps();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    uikTwoComponentRowProps.id = id;
  }

  final UikAction? action = jsonConvert.convert<UikAction>(json['action']);
  if (action != null) {
    uikTwoComponentRowProps.action = action;
  }

  final bool? enablePadding = jsonConvert.convert<bool>(json['enablePadding']);
  if (action != null) {
    uikTwoComponentRowProps.enablePadding = enablePadding ?? false;
  }

  final String? bgcolor = jsonConvert.convert<String>(json['bgcolor']);
  if (bgcolor != null) {
    uikTwoComponentRowProps.bgcolor = bgcolor.toColor();
  }

  final String? firstComponent =
      jsonConvert.convert<String>(json['firstComponent']);
  print(firstComponent);
  // print(firstComponent);
  if (firstComponent != null) {
    if (json['firstComponent']["id"] == "text") {
      uikTwoComponentRowProps.firstComponent = UikContainerText(
          WidgetType.UikContainerText,
          UikContainerTextProps.fromJson(json['firstComponent']));
    }

    if (json['firstComponent']["id"] == "cell") {
      uikTwoComponentRowProps.firstComponent = UikCell(
          WidgetType.UikContainerText,
          UikCellProps.fromJson(json['firstComponent']));
    }

    if (json['firstComponent']["id"] == "product") {
      uikTwoComponentRowProps.firstComponent = UikProductCardGrid(
          WidgetType.UikContainerText,
          UikProductCardGridProps.fromJson(json['firstComponent']));
    }

    if (json['firstComponent']["id"] == "column") {
      uikTwoComponentRowProps.firstComponent = UikColumn(
          WidgetType.UikContainerText,
          UikColumnProps.fromJson(json['firstComponent']));
    }

    if (json['firstComponent']["id"] == "stepper") {
      uikTwoComponentRowProps.firstComponent = UikStepper(
          WidgetType.UikText, UikStepperProps.fromJson(json['firstComponent']));
    }

    if (json['firstComponent']["id"] == "search") {
      uikTwoComponentRowProps.firstComponent = UikSearch(WidgetType.UikSearch,
          UikSearchProps.fromJson(json['firstComponent']));
    }

    if (json['firstComponent']["id"] == "button") {
      uikTwoComponentRowProps.firstComponent = UikButton(WidgetType.UikButton,
          UikButtonProps.fromJson(json['firstComponent']));
    }

    if (json['firstComponent']["id"] == "chip") {
      uikTwoComponentRowProps.firstComponent = UikTextChip(WidgetType.UikText,
          UikTextChipProps.fromJson(json['firstComponent']));
    }

    if (json['firstComponent']["id"] == "icon") {
      uikTwoComponentRowProps.firstComponent = UikIcon(
          WidgetType.UikText, UikIconProps.fromJson(json['firstComponent']));
    }

    if (json['firstComponent']["id"] == "image") {
      uikTwoComponentRowProps.firstComponent = UikImage(
          WidgetType.UikText, UikImageProps.fromJson(json['firstComponent']));
    }
  }

  final String? secondComponent =
      jsonConvert.convert<String>(json['secondComponent']);
  if (secondComponent != null) {
    if (json['secondComponent']["id"] == "text") {
      uikTwoComponentRowProps.secondComponent = UikContainerText(
          WidgetType.UikContainerText,
          UikContainerTextProps.fromJson(json['secondComponent']));
    }
    if (json['secondComponent']["id"] == "radioButton") {
      uikTwoComponentRowProps.secondComponent = UikRadioButton(
          WidgetType.UikContainerText,
          UikRadioButtonProps.fromJson(json['secondComponent']));
    }

    if (json['secondComponent']["id"] == "stepper") {
      uikTwoComponentRowProps.secondComponent = UikStepper(WidgetType.UikText,
          UikStepperProps.fromJson(json['secondComponent']));
    }

    if (json['secondComponent']["id"] == "cell") {
      uikTwoComponentRowProps.secondComponent = UikCell(
          WidgetType.UikContainerText,
          UikCellProps.fromJson(json['secondComponent']));
    }

    if (json['secondComponent']["id"] == "column") {
      uikTwoComponentRowProps.secondComponent = UikColumn(
          WidgetType.UikContainerText,
          UikColumnProps.fromJson(json['secondComponent']));
    }

    if (json['secondComponent']["id"] == "search") {
      uikTwoComponentRowProps.secondComponent = UikSearch(WidgetType.UikSearch,
          UikSearchProps.fromJson(json['secondComponent']));
    }

    if (json['secondComponent']["id"] == "button") {
      uikTwoComponentRowProps.secondComponent = UikButton(WidgetType.UikButton,
          UikButtonProps.fromJson(json['secondComponent']));
    }

    if (json['secondComponent']["id"] == "chip") {
      uikTwoComponentRowProps.secondComponent = UikTextChip(WidgetType.UikText,
          UikTextChipProps.fromJson(json['secondComponent']));
    }

    if (json['secondComponent']["id"] == "icon") {
      uikTwoComponentRowProps.secondComponent = UikIcon(
          WidgetType.UikText, UikIconProps.fromJson(json['secondComponent']));
    }

    if (json['secondComponent']["id"] == "image") {
      uikTwoComponentRowProps.secondComponent = UikImage(
          WidgetType.UikText, UikImageProps.fromJson(json['secondComponent']));
    }
  }

  final double? leftMargin = jsonConvert.convert<double>(json['marginLeft']);
  if (leftMargin != null) {
    uikTwoComponentRowProps.marginLeft = leftMargin;
  }

  final double? rightMargin = jsonConvert.convert<double>(json['marginRight']);
  if (rightMargin != null) {
    uikTwoComponentRowProps.marginRight = rightMargin;
  }

  final double? topMargin = jsonConvert.convert<double>(json['marginTop']);
  if (topMargin != null) {
    uikTwoComponentRowProps.marginTop = topMargin;
  }

  final double? height = jsonConvert.convert<double>(json['height']);
  if (height != null) {
    uikTwoComponentRowProps.height = height;
  }

  final double? borderRadius =
      jsonConvert.convert<double>(json['borderRadius']);
  if (borderRadius != null) {
    uikTwoComponentRowProps.borderRadius = borderRadius;
  }

  final double? opacity = jsonConvert.convert<double>(json['opacity']);
  if (opacity != null) {
    uikTwoComponentRowProps.opacity = opacity;
  }

  final double? bottomMargin =
      jsonConvert.convert<double>(json['marginBottom']);
  if (bottomMargin != null) {
    uikTwoComponentRowProps.marginBottom = bottomMargin;
  }
  return uikTwoComponentRowProps;
}
