import 'dart:convert';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/generated/json/uik_text_props.g.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:flutter/material.dart';

import '../generated/json/uik_accordion_props.g.dart';
import 'WidgetProps.dart';

@JsonSerializable()
class UikAccordionProps extends WidgetProps {
  late String id;
  late UikAction action;

  late Widget rightComponent = Container();
  late Widget headerComponent = Container();
  late Widget contentComponent = Container();
  late double headerBorderRadius = 0.0;
  late Color headerBackgroundColor = Colors.blue;
  late double opacity = 1.0;
  late double paddingListBottom = 0.0;
  late double paddingListTop = 0.0;
  late double contentHorizontalPadding = 0.0;
  late double contentVerticalPadding = 0.0;
  late Color contentBackgroundColor = Colors.blue;
  late Color contentBorderColor = Colors.blue;

  UikAccordionProps();

  factory UikAccordionProps.fromJson(Map<String, dynamic> json) =>
      $UikAccordionPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
