import 'dart:convert';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/generated/json/uik_text_props.g.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:flutter/material.dart';
import '../generated/json/uik_image_props.g.dart';
import 'WidgetProps.dart';

@JsonSerializable()
class UikImageProps extends WidgetProps {
  late String id;
  late double width = 0.0;
  late double height = 0.0;
  late double topMargin = 0.0;
  late double leftMargin = 0.0;
  late double rightMargin = 0.0;
  late double bottomMargin = 0.0;
  late double topLeftRadius = 0.0;
  late double topRightRadius = 0.0;
  late double bottomLeftRadius = 0.0;
  late double bottomRightRadius = 0.0;
  late String url = "";
  late UikAction ? action = null;

  UikImageProps();

  factory UikImageProps.fromJson(Map<String, dynamic> json) =>
      $UikImagePropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
