import 'dart:convert';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:flutter/material.dart';

import '../generated/json/uik_search_props.g.dart';
import 'WidgetProps.dart';

@JsonSerializable()
class UikSearchProps extends WidgetProps {
  late String label = "";
  late Color? borderColor = null;
  late Widget frontSearchIcon = const Icon(
    Icons.search,
    color: Color(0xFF9E9E9E),
  );
  late Widget frontArrowIcon = const Icon(
    Icons.arrow_back,
    color: Color(0xFF9E9E9E),
  );
  late Widget rightIcon = const Icon(
    Icons.search,
    color: Color(0xFF9E9E9E),
  );
  late bool micIcon = false;
  late double topMargin = 0.0;
  late double bottomMargin = 0.0;
  late double leftMargin = 0.0;
  late double rightMargin = 0.0;
  late double width = 343.0;
  late double height = 48.0;
  late double borderRadius = 0.0;
  late double labelFontSize = 0.0;
  late String apiLink = "";
  late String labelFontWeight = "FontWeight.bold";
  late String id;
  late String text;
  late UikAction action;

  UikSearchProps();

  factory UikSearchProps.fromJson(Map<String, dynamic> json) =>
      $UikSearchPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
