import 'dart:convert';
import 'package:ui_sdk/generated/json/base/json_field.dart';
import 'package:ui_sdk/generated/json/uik_text_props.g.dart';
import 'package:ui_sdk/props/UikAction.dart';
import 'package:flutter/material.dart';

import 'WidgetProps.dart';

@JsonSerializable()
class UikTextProps extends WidgetProps {
  late String id;
  late String text = "";
  late String striketext = "";
  late Color color = Colors.black;
  late double leftMargin = 0.0;
  late double rightMargin = 0.0;
  late double bottomMargin = 0.0;
  late double topMargin = 0.0;
  FontWeight? fontWeight;
  late String? fontFamily = "Poppins";
  late double size = 20.0;
  bool isStriken = false;
  late UikAction action;
  late bool isStrike = false;

  UikTextProps();

  factory UikTextProps.fromJson(Map<String, dynamic> json) =>
      $UikTextPropsFromJson(json);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
