import 'dart:convert';
import 'package:json_editor/json_editor.dart';
import 'package:flutter/material.dart';
import 'package:http/http.dart' as http;
import 'NavigatorService.dart';
import 'StandardPage.dart';
import 'props/ApiResponse.dart';
import 'props/UikAction.dart';
import 'utils/pubsub/localpubsub.dart';

String global = "";

class Test extends StatefulWidget {
  Test();

  @override
  State<Test> createState() => _TestState();
}

class _TestState extends State<Test> {
  @override
  Widget build(BuildContext context) {
    double screenWidth = MediaQuery.of(context).size.width;
    double screenHeight = MediaQuery.of(context).size.height;
    return Material(
      child: Scaffold(
        appBar: AppBar(
          title: const Text(
            "SDK Convertor",
            style: TextStyle(
              fontWeight: FontWeight.bold,
            ),
          ),
          centerTitle: true,
          backgroundColor: Colors.amber,
        ),
        body: Row(
          children: [
            Container(
              width: screenWidth * 0.4,
              height: screenHeight * 0.9,
              decoration: BoxDecoration(border: Border.all(width: 1)),
              child: JsonEditor.string(
                jsonString: '''
        
           // copy and paste json here

    ''',
                onValueChanged: (value) {
                  global = value.toString();
                },
              ),
            ),
            SizedBox(
              width: screenWidth * 0.05,
            ),
            SizedBox(
              width: screenWidth * 0.1,
              child: ElevatedButton(
                onPressed: () {
                  setState(() {});
                },
                child: const Text("Convert"),
              ),
            ),
            SizedBox(
              width: screenWidth * 0.05,
            ),
            Container(
              width: screenWidth * 0.4,
              height: screenHeight * 0.9,
              decoration: BoxDecoration(border: Border.all(width: 1)),
              child: (global != "")
                  ? TestPage().page
                  : const Text("Please Enter the json in the editor"),
            ),
          ],
        ),
      ),
    );
  }
}

class TestPage extends StandardPage {
  @override
  dynamic getData() {
    return fetchAlbum;
  }

  @override
  Set<String?> getActions() {
    Set<String?> actionList = Set();
    return actionList;
  }

  @override
  getPageCallBackForAction() {
    return of;
  }

  void of(UikAction uikAction) {
    print(uikAction);
    var context = NavigationService.navigatorKey.currentContext;
    print(context);
    String type = uikAction.tap.type;
    switch (type) {
      case "OPEN_WEB":
        {
          print("OPEN_WEB");
        }
        break;
      default:
        {
          print("default switch case :(");
        }
        break;
    }
  }

  @override
  getPageContext() {
    return TestPage;
  }
  
  @override
  getDataTemp() {
    // TODO: implement getDataTemp
    throw UnimplementedError();
  }
}

Future<ApiResponse> fetchAlbum(args) async {
  final queryParameter = {
    "id": "eb5f37b2-ca34-40a1-83ba-cb161eb55e6e",
  };

  //https://bc4c-1-38-54-6.ngrok.io
  final response = await http.post(
      Uri.parse('https://bc4c-1-38-54-6.ngrok.io/products/get'),
      headers: {
        "ngrok-skip-browser-warning": "value",
      },
      body: {
        "categoryId": args.toString(),
      });

  print(response.body);

  return ApiResponse.fromJson(jsonDecode(global));
}
